import org.fenggui.render.lwjgl.EventHelper;
import org.fenggui.*;
import org.fenggui.event.*;
import org.fenggui.composites.Window;
import org.fenggui.layout.FormData;
import org.fenggui.layout.FormLayout;
import org.fenggui.layout.RowLayout;
import org.fenggui.layout.GridLayout;
import org.fenggui.layout.StaticLayout;
import org.fenggui.background.*;
import org.fenggui.border.*;
import org.fenggui.util.Color;
import org.fenggui.util.Spacing;
import org.fenggui.util.Point;
import org.fenggui.composites.MessageWindow;
import org.fenggui.ComboBox;
import com.threed.jpct.*;
import com.threed.jpct.util.*;
import com.threed.jpct.procs.*;

import java.util.*;
import java.io.*;


public class WidgetBuilder{
	public static final String BLANK_VALUE = "                     ";
	public static final String NOTHING_SELECTED = "<nothing selected>";
	public static final String OBJ_NAME = "object name           ";
	public static final int TE_TERRAIN_X = 1;
	public static final int TE_TERRAIN_Y = 2;
	public static final int TE_TERRAIN_Z = 3;
	public static final int TE_OBJ_KEY = 4;
	public static final int TE_OBJ_FILE = 5;
	public static final int TE_OBJ_SCALE = 6;
	public static final int TE_OBJ_DELTA_SCALE = 7;
	public static final int TE_OBJ_X = 8;
	public static final int TE_OBJ_Y = 9;
	public static final int TE_OBJ_Z = 10;
	public static final int TE_OBJ_DELTA_X = 11;
	public static final int TE_OBJ_DELTA_Y = 12;
	public static final int TE_OBJ_DELTA_Z = 13;
	public static final int TE_OBJ_X_ROT = 14;
	public static final int TE_OBJ_Y_ROT = 15;
	public static final int TE_OBJ_Z_ROT = 16;
	public static final int TE_OBJ_DELTA_X_ROT = 17;
	public static final int TE_OBJ_DELTA_Y_ROT = 18;
	public static final int TE_OBJ_DELTA_Z_ROT = 19;
	public static final int TE_OBJ_TRANSPARENCY = 20;
	public static final int TE_OBJ_CULLING = 21;
	public static final int TE_STEPPING = 22;

	public static final int ACTION_SET_OBJ_KEY = 1;
	public static final int ACTION_SET_OBJ_X = 2;
	public static final int ACTION_SET_OBJ_Y = 3;
	public static final int ACTION_SET_OBJ_Z = 4;
	public static final int ACTION_SET_OBJ_X_ROT = 5;
	public static final int ACTION_SET_OBJ_Y_ROT = 6;
	public static final int ACTION_SET_OBJ_Z_ROT = 7;
	public static final int ACTION_SET_OBJ_SCALE = 8;
	public static final int ACTION_SET_OBJ_CULLING = 9;
	public static final int ACTION_SET_OBJ_TRANSPARENCY = 10;

	public static final int ACTION_LOAD_XML = 11;
	public static final int ACTION_SAVE_XML = 12;
	public static final int ACTION_LOAD_TERRAIN = 13;
	public static final int ACTION_LOAD_OBJ = 14;
	public static final int ACTION_LOAD_LIGHT = 15;
	public static final int ACTION_LOAD_PROXY = 16;
	public static final int ACTION_MARKER_TOGGLE = 17;
	public static final int ACTION_SELECT_TOGGLE = 18;
	public static final int ACTION_CAMERA_TOGGLE = 19;
	public static final int ACTION_DELETE_OBJ = 20;
	public static final int ACTION_SELECT_TERRAIN = 21;

	public static final int ACTION_DECREASE = 22;
	public static final int ACTION_INCREASE = 23;

	public static final int GENERAL_SETTING_X = 0;
	public static final int GENERAL_SETTING_Y = 1;
	public static final int GENERAL_SETTING_Z = 2;
	public static final int GENERAL_SETTING_X_ROT = 3;
	public static final int GENERAL_SETTING_Y_ROT = 4;
	public static final int GENERAL_SETTING_Z_ROT = 5;
	public static final int GENERAL_SETTING_TRANSPARENCY = 6;
	public static final int GENERAL_SETTING_SCALE = 7;
	

	private HashMap _hsW = null;

	private GUIEventHandler _gui = null;
	private ToggableGroup<String> _action_group = null;
	private ComboBox _selected_list = null;

	private Window _dialog = null;	
	private Window _lightWindow = null;
	private Window _extWindow = null;
	private HashMap _hsExt = null;	

	private static org.fenggui.util.Point _lpoint = null;
	private static org.fenggui.util.Point _epoint = null;

	public ComboBox getSelectedList(){return _selected_list;}

	public int getGeneralSetting(){
		return RadioSelectionMapper.mapSelection((String)_action_group.getSelectedValue());
	}


	public void showMessageText(String s, Display desk){
		try{
			MessageWindow mw = new MessageWindow(s);
			desk.addWidget(mw);
			mw.setTitle("");
			mw.setSize(300, 100);
			mw.setX(400);
			mw.setY(400);
			
			desk.layout();

		}catch(Exception e){
			System.err.println("WidgetBuilder::showMessageText() " + e.getMessage());
			e.printStackTrace();
		}
	}

	public float getStepping(){
		float f = 0.0f;
		try{
			TextEditor te = (TextEditor)_hsW.get(new Integer(TE_STEPPING));
			f = Float.parseFloat(te.getText());

		}catch(Exception e){
			System.err.println("WidgetBuilder::getStepping() " + e.getMessage());
			e.printStackTrace();
		}
		return f;
	}

	public void init(GUIEventHandler gui, Display desk){
		try{
			_gui = gui;
			_hsW = new HashMap();
			
			buildFloatingWindow(desk);	
			
			_lpoint = new org.fenggui.util.Point(400,300);
			_epoint = new org.fenggui.util.Point(400,300);
					

		}catch(Exception e){
			System.err.println("WidgetBuilder::init() " + e.getMessage());
			e.printStackTrace();
		}
	}

	/*private void doButtonAction(int iaction){
		try{
			
			_gui.doButtonAction(iaction);
					
		}catch(Exception e){
			System.err.println("WidgetBuilder::doButtonAction() " + e.getMessage());
			e.printStackTrace();
		}
	}*/

	/*private void doDialogAction(String s, int iAction){
		try{

			_gui.doDialogAction(s, iAction);

		}catch(Exception e){
			System.err.println("WidgetBuilder::doDialogAction() " + e.getMessage());
			e.printStackTrace();
		}
	}*/			

	
	private org.fenggui.Button addButton(String sval, final int iaction){
		org.fenggui.Button b = null;
		try{
			b = new org.fenggui.Button(sval);

			b.addButtonPressedListener(
					new IButtonPressedListener(){
						public void buttonPressed(ButtonPressedEvent e){
							_gui.doButtonAction(iaction);
						}
					}
				);

		}catch(Exception e){
			System.err.println("WidgetBuilder::addTextEditor() " + e.getMessage());
			e.printStackTrace();
		}
		return b;
	}

	public String getFieldText(int idx){
		String sret = null;
		try{
			TextEditor te = (TextEditor)_hsW.get(new Integer(idx));
			sret = te.getText();

		}catch(Exception e){
			System.err.println("WidgetBuilder::getFieldText() " + e.getMessage());
			e.printStackTrace();
		}
		return sret;
	}

	public void updateText(String s, int idx){
		try{
			TextEditor te = (TextEditor)_hsW.get(new Integer(idx));
			te.setText(s);

		}catch(Exception e){
			System.err.println("WidgetBuilder::updateText() " + e.getMessage());
			e.printStackTrace();
		}
	}

	private TextEditor addTextEditor(String sval, int idx){
		TextEditor te = null;
		try{
			te = new TextEditor(false);
    		te.setText(sval);
			
			_hsW.put(new Integer(idx), te);
		}catch(Exception e){
			System.err.println("WidgetBuilder::addTextEditor() " + e.getMessage());
			e.printStackTrace();
		}
		return te;
	}			

	public static void populateFileList(ComboBox lst, String sdir){
		try{
			File dir = new File(sdir);
    		File []  flst = dir.listFiles(); 
 
    		if (flst != null) {
        		for(int i=0; i<flst.length; i++) {
					
            		if(flst[i].isFile()){
						//System.out.println("WidgetBuilder::populateFileList() adding file [" 
						//	+ sdir + "/" + flst[i].getName() + "]");
            			lst.addItem(sdir + "/" + flst[i].getName());
					}
				}
			}
		}catch(Exception e){
			System.err.println("WidgetBuilder::populateFileList() " + e.getMessage());
			e.printStackTrace();
		}
	}

	public void doUpdateLightAttributes(Float fattenuation, float fr, float fg, float fb){
		try{
			ObjectAttributes oa = _gui.getObjectsLoader().getSelectedLight();
			if(oa != null){
				oa.attenuation = fattenuation;
				oa.intensity_r = fr;
				oa.intensity_g = fg;
				oa.intensity_b = fb;
				SimpleVector v = new SimpleVector(fr, fg, fb);
				oa.light.setIntensity(v);
				oa.light.setAttenuation(fattenuation);
				oa.light.enable();
			}

		}catch(Exception e){
			System.err.println("WidgetBuilder::doUpdateLightAttributes() " + e.getMessage());
			e.printStackTrace();
		}
	}

	public void showLightWindow(ObjectAttributes oa, Display desk){
		try{

			hideLightWindow();
			
			_lightWindow = new Window(true, false, false, true);
			desk.addWidget(_lightWindow);
			_lightWindow.setXY(_lpoint.getX(), _lpoint.getY());
			_lightWindow.setSize(200, 150);
			_lightWindow.setShrinkable(false);
			_lightWindow.setTitle("Light Properties");
			_lightWindow.getContentContainer().setLayoutManager(new RowLayout(false));
			
			Container c = new Container();
			c.setLayoutManager(new GridLayout(5, 2));

			c.addWidget(new Label(" attenuation        "));
			final TextEditor teAttenuation = new TextEditor(false);
			teAttenuation.setText(Float.toString(oa.attenuation));
			teAttenuation.setSizeToMinSize();
			c.addWidget(teAttenuation);

			c.addWidget(new Label(" intensity R        "));
			final TextEditor teIntR = new TextEditor(false);
			teIntR.setText(Float.toString(oa.intensity_r));
			teIntR.setSizeToMinSize();
			c.addWidget(teIntR);

			c.addWidget(new Label(" intensity G        "));
			final TextEditor teIntG = new TextEditor(false);
			teIntG.setText(Float.toString(oa.intensity_g));
			teIntG.setSizeToMinSize();
			c.addWidget(teIntG);

			c.addWidget(new Label(" intensity B        "));
			final TextEditor teIntB = new TextEditor(false);
			teIntB.setText(Float.toString(oa.intensity_b));
			teIntB.setSizeToMinSize();
			c.addWidget(teIntB);
			
			org.fenggui.Button bset = new org.fenggui.Button("Set Values");
			bset.setSizeToMinSize();
			c.addWidget(bset);
			bset.addButtonPressedListener(
					new IButtonPressedListener(){
						public void buttonPressed(ButtonPressedEvent e){
							doUpdateLightAttributes(
										Float.valueOf(teAttenuation.getText()),
										Float.valueOf(teIntR.getText()),
										Float.valueOf(teIntG.getText()),
										Float.valueOf(teIntB.getText()));
						}
					}
				);

			org.fenggui.Button bclose = new org.fenggui.Button("  Close  ");
			bclose.setSizeToMinSize();
			c.addWidget(bclose);
			bclose.addButtonPressedListener(
					new IButtonPressedListener(){
						public void buttonPressed(ButtonPressedEvent e){
							hideLightWindow();
						}
					}
				);
			
			c.pack();
			_lightWindow.addWidget(c);
			_lightWindow.setSize(c.getWidth()+15, c.getHeight()+30);
			desk.layout();

			
		}catch(Exception e){
			System.err.println("WidgetBuilder::showLightWindow() " + e.getMessage());
			e.printStackTrace();
		}
	}

	public void hideLightWindow(){
		try{
			
			if(_lightWindow != null){
				try{
					
					_lpoint = new org.fenggui.util.Point(_lightWindow.getX(), _lightWindow.getY());
					_lightWindow.removeAllWidgets();
					_lightWindow.close();


				}catch(Exception ei){}
				_lightWindow = null;
			}

		}catch(Exception e){
			System.err.println("WidgetBuilder::hideLightWindow() " + e.getMessage());
			e.printStackTrace();
		}
	}


	public void showDialog(Display desk, String spath, final int iaction, String stitle, String sbttext){
		try{
			if(_dialog == null){
				_dialog = new Window(true, false, false, true);
				desk.addWidget(_dialog);
				_dialog.setX(400);
				_dialog.setY(300);
				_dialog.setSize(400, 100);
				_dialog.setShrinkable(false);

				_dialog.setTitle(stitle);

				_dialog.getContentContainer().setLayoutManager(new StaticLayout());

				final ComboBox list = new ComboBox();
				_dialog.getContentContainer().addWidget(list);
				list.setSize(385, list.getMinHeight());
				list.setShrinkable(false);
				list.setX(5);
				list.setY(30);


				populateFileList(
						list,
						DevkitConfig.getInstance().getValue(spath));
			
				org.fenggui.Button bload = new org.fenggui.Button(sbttext);
				bload.setX(25);
				bload.setY(5);
				bload.setSizeToMinSize();
				_dialog.addWidget(bload);
				bload.addButtonPressedListener(
						new IButtonPressedListener(){
							public void buttonPressed(ButtonPressedEvent e){
								_gui.doDialogAction(list.getLabel().getText(), iaction);
								try{
									_dialog.removeAllWidgets();
									_dialog.close();
								}catch(Exception ei){}
								_dialog = null;
							}
						}
					);

				org.fenggui.Button bcancel = new org.fenggui.Button("Cancel");
				bcancel.setX(70);
				bcancel.setY(5);
				bcancel.setSizeToMinSize();
				_dialog.addWidget(bcancel);
				bcancel.addButtonPressedListener(
						new IButtonPressedListener(){
							public void buttonPressed(ButtonPressedEvent e){
								try{
									_dialog.removeAllWidgets();
									_dialog.close();
								}catch(Exception ei){}
								_dialog = null;
							}
						}
					);

				desk.layout();
			}

		}catch(Exception e){
			System.err.println("WidgetBuilder::showDialog() " + e.getMessage());
			e.printStackTrace();
		}
	}			

	/*private void doSwitchSelectedObject(String sname){
		try{
			_gui.updateSelectedObject(sname);
		}catch(Exception e){
			System.err.println("WidgetBuilder::doSwitchSelectedObject() " + e.getMessage());
			e.printStackTrace();
		}
	}*/

	private void initSelectedList(){
		try{
			_selected_list = new ComboBox();
			_selected_list.setSize(25, _selected_list.getMinHeight());
			_selected_list.setShrinkable(false);
			
			_selected_list.addItem(WidgetBuilder.NOTHING_SELECTED);

			_selected_list.addSelectionChangedListener(
					new ISelectionChangedListener(){
						public void selectionChanged(SelectionChangedEvent e){
							if(e.isSelected())
								_gui.updateSelectedObject(_selected_list.getLabel().getText());
						}
					}
			);

		}catch(Exception e){
			System.err.println("WidgetBuilder::initSelectedList() " + e.getMessage());
			e.printStackTrace();
		}
	}

	private Container initPropsLayout(){
		Container c = null;
		try{

			c = new Container();
	        c.setLayoutManager(new GridLayout(18, 3));

			c.addWidget(new Label(" key "));
			c.addWidget(addTextEditor("", TE_OBJ_KEY));
			c.addWidget(new Label(""));

			c.addWidget(new Label(" file "));
			c.addWidget(addTextEditor("", TE_OBJ_FILE));
			c.addWidget(new Label(""));

			c.addWidget(new Label(" scale "));
			c.addWidget(addTextEditor("", TE_OBJ_SCALE));
			c.addWidget(addButton("set", ACTION_SET_OBJ_SCALE));

			c.addWidget(new Label(" delta scale "));
			c.addWidget(addTextEditor("", TE_OBJ_DELTA_SCALE));
			c.addWidget(new Label(""));

			c.addWidget(new Label(" x "));
			c.addWidget(addTextEditor("0.000000000", TE_OBJ_X));
			c.addWidget(addButton("set", ACTION_SET_OBJ_X));
			c.addWidget(new Label(" y "));
			c.addWidget(addTextEditor("0.000000000", TE_OBJ_Y));
			c.addWidget(addButton("set", ACTION_SET_OBJ_Y));
			c.addWidget(new Label(" z "));
			c.addWidget(addTextEditor("0.000000000", TE_OBJ_Z));
			c.addWidget(addButton("set", ACTION_SET_OBJ_Z));
			c.addWidget(new Label(" delta x "));
			c.addWidget(addTextEditor("0.000000000", TE_OBJ_DELTA_X));
			c.addWidget(new Label(""));
			c.addWidget(new Label(" delta y "));
			c.addWidget(addTextEditor("0.000000000", TE_OBJ_DELTA_Y));
			c.addWidget(new Label(""));
			c.addWidget(new Label(" delta z "));
			c.addWidget(addTextEditor("0.000000000", TE_OBJ_DELTA_Z));
			c.addWidget(new Label(""));


			c.addWidget(new Label(" x_rot "));
			c.addWidget(addTextEditor("0.000000000", TE_OBJ_X_ROT));
			c.addWidget(addButton("set", ACTION_SET_OBJ_X_ROT));
			c.addWidget(new Label(" y_rot "));
			c.addWidget(addTextEditor("0.000000000", TE_OBJ_Y_ROT));
			c.addWidget(addButton("set", ACTION_SET_OBJ_Y_ROT));
			c.addWidget(new Label(" z_rot "));
			c.addWidget(addTextEditor("0.000000000", TE_OBJ_Z_ROT));
			c.addWidget(addButton("set", ACTION_SET_OBJ_Z_ROT));
			c.addWidget(new Label(" delta x_rot "));
			c.addWidget(addTextEditor("0.000000000", TE_OBJ_DELTA_X_ROT));
			c.addWidget(new Label(""));
			c.addWidget(new Label(" delta y_rot "));
			c.addWidget(addTextEditor("0.000000000", TE_OBJ_DELTA_Y_ROT));
			c.addWidget(new Label(""));
			c.addWidget(new Label(" delta z_rot "));
			c.addWidget(addTextEditor("0.000000000", TE_OBJ_DELTA_Z_ROT));
			c.addWidget(new Label(""));


			c.addWidget(new Label(" transparency "));
			c.addWidget(addTextEditor("100", TE_OBJ_TRANSPARENCY));
			c.addWidget(addButton("set", ACTION_SET_OBJ_TRANSPARENCY));

			c.addWidget(new Label(" culling "));
			c.addWidget(addTextEditor("false", TE_OBJ_CULLING));
			c.addWidget(addButton("set", ACTION_SET_OBJ_CULLING));
			
			c.pack();
	
		}catch(Exception e){
			System.err.println("WidgetBuilder::initPropsLayout() " + e.getMessage());
			e.printStackTrace();
		}
		return c;
	}	

	private void addOptionList(Container c){
		try{
        	_action_group = new ToggableGroup<String>();

			Container copt = new Container();
			copt.setLayoutManager(new GridLayout(4, 3));

			
			copt.addWidget(new RadioButton<String>(
						" " + RadioSelectionMapper.RADIO_X, _action_group, RadioSelectionMapper.RADIO_X));
	        copt.addWidget(new RadioButton<String>(
						" " + RadioSelectionMapper.RADIO_Y, _action_group, RadioSelectionMapper.RADIO_Y));
			copt.addWidget(new RadioButton<String>(
						" " + RadioSelectionMapper.RADIO_Z, _action_group, RadioSelectionMapper.RADIO_Z));
	        copt.addWidget(new RadioButton<String>(
						" " + RadioSelectionMapper.RADIO_X_ROT, _action_group, RadioSelectionMapper.RADIO_X_ROT));
			copt.addWidget(new RadioButton<String>(
						" " + RadioSelectionMapper.RADIO_Y_ROT, _action_group, RadioSelectionMapper.RADIO_Y_ROT));
	        copt.addWidget(new RadioButton<String>(
						" " + RadioSelectionMapper.RADIO_Z_ROT, _action_group, RadioSelectionMapper.RADIO_Z_ROT));
	        copt.addWidget(new RadioButton<String>(
						" " + RadioSelectionMapper.RADIO_SCALE, _action_group, RadioSelectionMapper.RADIO_SCALE));
	        copt.addWidget(new RadioButton<String>(
						" " + RadioSelectionMapper.RADIO_TRANSPARENCY, _action_group, RadioSelectionMapper.RADIO_TRANSPARENCY));
			
			copt.pack();
			c.addWidget(copt);

		}catch(Exception e){
			System.err.println("Widgetbuilder::addOptionList() " + e.getMessage());
			e.printStackTrace();
		}
	}

	private Container addAdjuster(){
		Container c = null;
		try{
			c = new Container();
	        c.setLayoutManager(new GridLayout(2, 3));
			c.getAppearance().add(new PlainBorder(new Color(255, 0, 0, 160), 2));
			c.addWidget(new Label("Stepping"));
			c.addWidget(new Label("    "));
			c.addWidget(addTextEditor("1.0", TE_STEPPING));
			c.addWidget(addButton("      <<<<     ", ACTION_DECREASE));
			c.addWidget(new Label("    "));
			c.addWidget(addButton("      >>>>     ", ACTION_INCREASE));
			c.pack();
		}catch(Exception e){
			System.err.println("WidgetBuilder::addAdjuster() " + e.getMessage());
			e.printStackTrace();
		}
		return c;
	}

	private void buildFloatingWindow(Display desk){
		try{

			final Window win = new Window(false, false, false, true);
	        win.setTitle("Property Adjuster");
	        desk.addWidget(win);
			Container c = win.getContentContainer();
	        c.setLayoutManager(new RowLayout(false));
			c.getAppearance().add(new PlainBackground(new Color(176, 186, 219, 110)));
	        c.getAppearance().add(new PlainBorder(new Color(0, 0, 255, 160), 2));
			c.getAppearance().setPadding(new Spacing(5, 5));

			c.addWidget(buildTerrainWindow());

			c.addWidget(buildUtilButtonsWindow());

			addOptionList(c);
						
			c.addWidget(addAdjuster());
			
			initSelectedList();
			c.addWidget(_selected_list);

			c.addWidget(initPropsLayout());

			win.pack();

	        win.setX(100);
	        win.setY(desk.getHeight() - (win.getHeight() + 30));

		}catch(Exception e){
			System.err.println("WidgetBuilder::buildAdjusterWindow() " + e.getMessage());
			e.printStackTrace();
		}
	}

	private Container buildUtilButtonsWindow(){
		Container c = null;
		try{
			
			c = new Container();
	        c.setLayoutManager(new RowLayout(false));
			c.getAppearance().add(new PlainBorder(new Color(0, 0, 255, 160), 2));
			
			Container cpersist = new Container();
			cpersist.setLayoutManager(new GridLayout(1, 3));
	        cpersist.addWidget(addButton("Load XML", ACTION_LOAD_XML));
			cpersist.addWidget(new Label("       "));			            
	        cpersist.addWidget(addButton("Save XML", ACTION_SAVE_XML));
			cpersist.pack();
			c.addWidget(cpersist);

			c.addWidget(new Label("Load Object Types"));
			Container cload = new Container();
			cload.setLayoutManager(new GridLayout(1, 4));
	        cload.addWidget(addButton(" Terrain ", ACTION_LOAD_TERRAIN));			            
	        cload.addWidget(addButton(" Object ", ACTION_LOAD_OBJ));
	        cload.addWidget(addButton(" Light ", ACTION_LOAD_LIGHT));
	        cload.addWidget(addButton(" Proxy ", ACTION_LOAD_PROXY));
			cload.pack();
			c.addWidget(cload);

			c.addWidget(new Label("Object Actions"));
			Container cselect = new Container();
			cselect.setLayoutManager(new GridLayout(1, 3));
			cselect.addWidget(addButton(" Select Object ", ACTION_SELECT_TOGGLE));
			cselect.addWidget(addButton("Delete Selected", ACTION_DELETE_OBJ));           
	        cselect.addWidget(addButton(" Place Marker ", ACTION_MARKER_TOGGLE));            
			cselect.pack();
			c.addWidget(cselect);			

			Container cselect2 = new Container();
			cselect2.setLayoutManager(new GridLayout(1, 2));
			cselect2.addWidget(addButton(" Select Terrain ", ACTION_SELECT_TERRAIN));
			cselect2.addWidget(addButton(" Place Camera ", ACTION_CAMERA_TOGGLE));
			           
			cselect2.pack();
			c.addWidget(cselect2);			


			
			c.pack();

		}catch(Exception e){
			System.err.println("WidgetBuilder::buildUtilButtonsWindow() " + e.getMessage());
			e.printStackTrace();
		}
		return c;
	}

	public Container buildTerrainWindow(){
		Container c = null;
		try{
			
			c = new Container();

	        c.setLayoutManager(new GridLayout(2, 3));
	        //&&c.setXY(5, desk.getHeight()-82);
	        c.getAppearance().add(new PlainBackground(new Color(176, 186, 219, 160)));
	        c.getAppearance().add(new PlainBorder(new Color(0, 0, 255, 160), 2));
			c.addWidget(new Label(""));
			c.addWidget(new Label("Terrain Coords"));
			c.addWidget(new Label(""));            
			c.addWidget(addTextEditor("0.00000000000", TE_TERRAIN_X));
			c.addWidget(addTextEditor("0.00000000000", TE_TERRAIN_Y));
			c.addWidget(addTextEditor("0.00000000000", TE_TERRAIN_Z));
			
			c.pack();
			//desk.addWidget(c);
			//c.setXY(5, desk.getHeight() - (c.getHeight() + 50));
	        

		}catch(Exception e){
			System.err.println("WidgetBuilder::buildTerrainWindow() " + e.getMessage());
			e.printStackTrace();
		}
		return c;
    }

	public void doUpdateExtensionAttributes(){
		try{
			
			TextEditor tename = (TextEditor)_hsExt.get(OBJ_NAME);

			ObjectAttributes oa = _gui.getObjectAttributesByName(tename.getText());

			Iterator it = _hsExt.keySet().iterator();
			while (it.hasNext()) {
				String sname = (String)it.next();
				if(!sname.equals(OBJ_NAME)){
					TextEditor te = (TextEditor)_hsExt.get(sname);
					oa.setExtensionStringValue(sname, te.getText());				
				}
			}

		}catch(Exception e){
			System.err.println("WidgetBuilder::doUpdateExtensionAttributes() " + e.getMessage());
			e.printStackTrace();
		}
	}
	
	public void hideExtensionsWindow(){
		try{
			if(_extWindow != null){
				try{
					_epoint = new org.fenggui.util.Point(_extWindow.getX(), _extWindow.getY());
					_extWindow.removeAllWidgets();
					_extWindow.close();
				}catch(Exception ei){}
				_extWindow = null;
			}
		}catch(Exception e){
			System.err.println("WidgetBuilder::hideExtensionsWindow() " + e.getMessage());
			e.printStackTrace();
		}
	}

	public void showProxyChoiceDialog(Display desk){
		try{
			final Window w = new Window(true, false, false, true);
			desk.addWidget(w);
			w.setXY(350, 350);
		
			w.setShrinkable(false);
			w.setTitle("Create Proxy Object Dialog");
			w.getContentContainer().setLayoutManager(new RowLayout(false));

			Container c = new Container();
			c.setLayoutManager(new RowLayout(false));


        	final ToggableGroup<String> t = new ToggableGroup<String>();
			Container copt = new Container();
			copt.setLayoutManager(new RowLayout(false));
			copt.addWidget(new RadioButton<String>(" Spawn Point", t, ObjectsLoader.PROXY_TYPE_SPAWN_POINT));
	        copt.addWidget(new RadioButton<String>(" Portal", t, ObjectsLoader.PROXY_TYPE_PORTAL));
	        copt.addWidget(new RadioButton<String>(" Trigger", t, ObjectsLoader.PROXY_TYPE_TRIGGER));

			copt.pack();
			c.addWidget(copt);

			Container cbt = new Container();		
			org.fenggui.Button bset = new org.fenggui.Button("Create Proxy");
			bset.setSizeToMinSize();
			cbt.addWidget(bset);
			bset.addButtonPressedListener(
					new IButtonPressedListener(){
						public void buttonPressed(ButtonPressedEvent e){
							_gui.createProxyObject((String)t.getSelectedValue());
							try{
								w.removeAllWidgets();
								w.close();
							}catch(Exception ei){}
						}
					}
				);

			org.fenggui.Button bclose = new org.fenggui.Button("  Close  ");
			bclose.setSizeToMinSize();
			cbt.addWidget(bclose);
			bclose.addButtonPressedListener(
					new IButtonPressedListener(){
						public void buttonPressed(ButtonPressedEvent e){
							try{
								w.removeAllWidgets();
								w.close();
							}catch(Exception ei){}
						}
					}
				);

			c.addWidget(cbt);
			c.pack();
			w.setSize(c.getWidth()+15, c.getHeight()+30);

			w.addWidget(c);
			desk.layout();
		
		}catch(Exception e){
			System.err.println("WidgetBuilder::showProxyChoiceDialog() " + e.getMessage());
			e.printStackTrace();
		}
	}

	public void buildExtensionsWindow(ObjectAttributes oa, Display desk){
		try{
			Vector v = oa.getExtensions();
			if(v.size() > 0){

				hideExtensionsWindow();

				_extWindow = new Window(true, false, false, true);
				desk.addWidget(_extWindow);
				_extWindow.setXY(_epoint.getX(), _epoint.getY());
			
				_extWindow.setShrinkable(false);
				_extWindow.setTitle("Extension Properties");
				_extWindow.getContentContainer().setLayoutManager(new RowLayout(false));

				Container call = new Container();
				call.setLayoutManager(new RowLayout(false));

				_hsExt = new HashMap();				

				Container cn = new Container();
				cn.setLayoutManager(new GridLayout(v.size() + 1, 2));
				cn.addWidget(new Label(OBJ_NAME));
				TextEditor ten = new TextEditor(false);
				ten.setText(oa.obj3D.getName());
				ten.setSizeToMinSize();
				ten.setWidth(ten.getWidth() + 10);
				cn.addWidget(ten);
				_hsExt.put(OBJ_NAME, ten);
				

				for(int i=0; i < v.size(); i++){
					NVPair nv = (NVPair)v.elementAt(i);
					cn.addWidget(new Label("  " + nv.name + "  "));
					TextEditor te = new TextEditor(false);
					te.setText(nv.value);
					te.setSize(ten.getSize());
					cn.addWidget(te);
					_hsExt.put(nv.name, te);
				}
				call.addWidget(cn);
				
				Container cbt = new Container();		
				org.fenggui.Button bset = new org.fenggui.Button("Set Values");
				bset.setSizeToMinSize();
				cbt.addWidget(bset);
				bset.addButtonPressedListener(
						new IButtonPressedListener(){
							public void buttonPressed(ButtonPressedEvent e){
								doUpdateExtensionAttributes();
							}
						}
					);

				org.fenggui.Button bclose = new org.fenggui.Button("  Close  ");
				bclose.setSizeToMinSize();
				cbt.addWidget(bclose);
				bclose.addButtonPressedListener(
						new IButtonPressedListener(){
							public void buttonPressed(ButtonPressedEvent e){
								try{
									_extWindow.removeAllWidgets();
									_extWindow.close();
								}catch(Exception ei){}
								_extWindow = null;
							}
						}
					);

				call.addWidget(cbt);
				call.pack();
				_extWindow.setSize(call.getWidth()+15, call.getHeight()+30);

				_extWindow.addWidget(call);
				desk.layout();
			}

		}catch(Exception e){
			System.err.println("WidgetBuilder::buildExtensionsWindow() " + e.getMessage());
			e.printStackTrace();
		}
	}
}